/*
 * file:        LED.h
 * purpose:     define a class for LED handling
 * project:     c++ framework for avr controllers
 * author:      Karl-Heinz Buchegg (http://www.mikrocontroller.net/topic/350418#3892395)
 */
#ifndef LED_H
#define LED_H
#pragma once
#include "Pin.h"

namespace srd {

class LED
{
public:
  LED(const Pin& pin)
  : pin(pin) {
    this->pin.toOutput();
    }

  void On()     { pin.setHigh(); }
  void Off()    { pin.setLow();  }
  void toggle() { pin.toggle();  }

private:
  Pin pin;
  };
}
#endif
