/*
 * file:        PWM.h
 * purpose:     class for pwm manipulation of a digital output pin
 * project:     c++ framework for avr controllers
 * author:      Reinhard Mantey
 * copyright:   2003-2016 (c) Creative commons - by-nc-sa - some rights reserved
 *              see http://creativecommons.org/licenses/by-nc-sa/3.0/ for details
 */
#ifndef PWM_H
#define PWM_H

namespace srd {

template<typename TimerClass>
class PWM
{
public:
  PWM(const TimerClass& timer, const Channel ch, const ChannelMode mode)
   : timer(timer)
   , channel(ch) {
    timer.enableChannel(ch, mode);
    };

  void setDuty(int16_t value) const {
    timer.setCompareValue(channel, value);
    };

private:
  const TimerClass& timer;
  const Channel channel;
  };

}
#endif
