/*
 * file:        halConfig.h
 * purpose:     hardware abstraction and configuration
 * project:     c++ framework for avr controllers
 * author:      Reinhard Mantey
 * copyright:   2003-2016 (c) Creative commons - by-nc-sa - some rights reserved
 *              see http://creativecommons.org/licenses/by-nc-sa/3.0/ for details
 */
#ifndef HALCONFIG_H
#define HALCONFIG_H
/*
 * module usage:    no modules:                  878 bytes program      51 bytes data
 *  (i.e. mega16)   HAVE_SYSTEMTICK:            1272 bytes program      59 bytes data
 *  sizes may       HAVE_SERIAL_COMM:           1422 bytes program      70 bytes data
 *  differ on       HAVE_BUZZER:                1096 bytes program      51 bytes data
 *  other           HAVE_ENCODER:               1682 bytes program      75 bytes data
 *  devices         HAVE_ADC:                   2092 bytes program     135 bytes data
 *                  HAVE_ADC + ADC_WITH_TIMER:  2088 bytes program     135 bytes data
 *                  HAVE_LCD:                   3124 bytes program     127 bytes data
 *                  all modules:                6084 bytes program     262 bytes data
 */
#define HAVE_SYSTEMTICK
#define HAVE_SERIAL_COMM
#define HAVE_BUZZER
#define HAVE_ENCODER
#define HAVE_ADC
#define ADC_WITH_TIMER
#define HAVE_LCD
#ifdef ADC_WITH_TIMER
# undef HAVE_BUZZER
#endif

// number of adc-cycles to get one value
// this number has impact on size of adc-module
#define NUM_OVERSAMPLING        4

/*
 * common stuff
 */
#define IO_CHECK            10                             // milliseconds to wait for next check
#define BUTTON_SAMPLING     12                             // number of times a button must be pressed

#define LCD_COLS            27
#define LCD_LINES           4
#define LCD_WANT_SAMPLE

#include "hal/halBase.h"

#pragma GCC diagnostic ignored "-Wwrite-strings"
#pragma GCC diagnostic ignored "-Wunused-parameter"

EXTERN void operator delete(void *unused);
EXTERN void operator delete(void *unused, unsigned int notUsed);

#endif
